=================
== What's New  ==
=================

10/01/12 2.1.0.11
-------------------------------------------------------------------------------
Fixed a bug when bootstrapping.

20/8/12 2.1.0.10
-------------------------------------------------------------------------------
Now sends album artist as parameter d in scrob sub protocol.


13/5/08 2.1.0.9
-------------------------------------------------------------------------------
Updates broken Updater.exe in client if installed.


11/1/07 2.1.0.8
-------------------------------------------------------------------------------
Added workaround for Winamp occasionally reporting the wrong artist name
which resulted in mixed up artist/track combinations.


29/11/07 2.1.0.7
-------------------------------------------------------------------------------
VS 2003 build.


22/11/07 2.1.0.6
-------------------------------------------------------------------------------
More debug output to try and catch a bootstrap crash.


19/11/07 2.1.0.5
-------------------------------------------------------------------------------
Import now also reading last played times.


19/11/07 2.1.0.4
-------------------------------------------------------------------------------
Fixed potential crash due to buffer overrun when requesting Unicode metadata.
Fixed stuck dialog when trying to import empty library.


15/11/07 2.1.0.3
-------------------------------------------------------------------------------
Bootstrapping added.


19/10/07 2.0.47.0
-------------------------------------------------------------------------------
Tracks with Unicode characters now show up correctly in task bar.
APE tags can now be read and sent to Last.fm.


18/10/07 2.0.46.0
-------------------------------------------------------------------------------
Fixed problem with new track detection in Winamp 5.5


31/7/07 2.0.45.0
-------------------------------------------------------------------------------
Recompiled with new ScrobSub for Vista compatibility.


17/7/07 2.0.43.0
-------------------------------------------------------------------------------
Fixed bug that made some people's machines hang.
Fixed taskbar track title getting corrupted.


11/7/07 2.0.35.0
-------------------------------------------------------------------------------
Now supports tracks with Unicode tags for Winamp versions above 5.13.


22/6/06 2.0.26.0
-------------------------------------------------------------------------------
Changed output name to ml_wa2_scrobbler.dll and recompiled with new ScrobSub
for the beta release of the new Last.fm client.


11/04/2006 2.0.22.0
------------------------
Added MMS: to excluded protocols. Allowed paths starting with \\. Added a Stop command on shutdown as WMP doesn't send a Stop otherwise. Bigger workaround for -1 bug, sleeping and retrying a few times as the Winamp forums said that it can return -1 if it hasn't had time to calculate the time yet.


22/03/2006 2.0.19.0
------------------------
Fixed it so that it calls stop also when in paused state.


22/03/2006 2.0.18.0
------------------------
Changed protocol to include Pause due to new AS progress indicator.


20/03/2006 2.0.16.0
------------------------
Fixed an off-by-one bug that converted artist or track names with one character wrong to UTF8.


28/02/2006 2.0.3.0 (Erik)
------------------------
Butchered plugin to work with new Audioscrobbler Service. All internet-related and caching functionality removed and ScrobSub installed for handling communication with AS.


31/08/2005 1.1.10 (lozzd - laurie@denness.net)
------------------------
Bug - Serious handshake/submissions server mismatch bug. 


07/03/2005 1.1.9 Final
----------------------
Change - Track plays are detected slightly differently which should stop Winamp from hanging when
         a new track is played
Change - Better error message when can't connect



21/02/2005 1.1.9 Beta 3
------------------------
Change - Add support for Global Hotkeys for enable/disable and show config
Change - Can include/exclude directories individually now (+ bugfixes)

12/01/2005 - 1.1.9 Beta 2
--------------------------
Bug - Song length -1 for tracks for which the track length couldn't be determined. Now default this to 240 (4 mins)

05/01/2005 - 1.1.9 Beta 1
--------------------------
Bug - Plugin wouldn't load settings on Windows 95
Bug - Player pauses for 5 seconds when cannot determine track length
Bug - Handshaking in 945098734s.
Change - Clearer handshake status messages
Change - If the current song length cannot be determined (because Player won't tell me), the song is submitted after the default of 240s. 
        If the song is less than 240s long, the submission won't take place. Best I can do under the circumstances I'm afraid.
Change - New Window in Winamp for Media Library users to monitor Audioscrobbler submission status. This is very experimental at the moment and might not make it into the final build.
Change - On HTTP Error drop connection and force a fresh handshake

18/10/2004 - Build 613
-----------------------
Bug - 'Can't find Winamp PE Window' bug
Bug - 'Song length -1 not allowed'
Bug - Song shown twice in last played in config dialog
Change - Tidied Config Dialog, removed logging option, added clear password button
Change - If using Proxy Authentication, 'Proxy-Connection: Keep-Alive' added to connection
Change - If handshake fails, try less and less often to connect (max 2hrs)

07/10/2004 - Build 612
-----------------------
Change - Remove song length limit

29/09/2004 - Build 611
-----------------------
Bug - Cache didn't send after server down until Winamp restarted
Change - More info on Config dialog

23/09/2004 - Build 610
-----------------------
Change - Better handling of errors during server downtime
Change - Cache is sent more frequently but is now limited to 1000 tracks
Change - Better error messages in Config dialog when tracks are invalid

22/09/2004 - Build 609
-----------------------
Bug - Don't submit new songs until the cache has been cleared

16/09/2004 - Build 608
-----------------------
Bug - Installer rename didn't work

15/09/2004 - Build 607
-----------------------
Bug - Log file size is displayed correctly now
Change - New Installer

01/09/2004 - Build 606
-----------------------
Change - Sends cache chunks less often (every 30 secs) to prevent server rejecting it
Change - Works as Gen or ML plugin
Bug - Fix (maybe) for -1 songs lengths

27/08/2004
-----------
Change - Removed some unneeded playback checks
Change - Can hide upgrade info if required
Change - Improved proxy handling 

02/06/2004
-----------
Change - Changed to be media library plugin instead. Should fix tagging issues

** 27/04/2004 - VERSION 1.1.7 Build 597 Released **

27/04/2004
-----------
Change - Removed Start menu shortcut and displaying of help file during installation
Big - Requests to audioscrobbler server were sometimes cached (on
       ISP proxy or wherever). Should explain why some submissions have been going missing.

26/04/2004
----------
Change - Allow users to force the plugin to try to connect even if no internet connection is detected.

22/04/2004
----------
Change - Message in Config dlg when not submitting because of untagged file

20/04/2004
----------
Bug - Make sure last submission is properley deleted from memory
Bug - Fixed CD Submissions
Change - Added ability to exclude or include files in certain directory paths
Change - Password can be cleared using the config dialog

15/04/2004
----------
Spib - Unsupported file type errors should be fixed
Spib - Only files which are TAGGED get submitted as specified in the protocol (guessing from filenames is not done)
Spib - Errors display only into config dialog and log - no more messageboxes
Spib - Cache submissions are logged to file
Spib - Server errors causing new handshake are logged to file
Spib - Minimum submit time is now 50% or 240s rather than 120s

** 05/03/2004 - VERSION 1.1.6 Build 592 Released **

24/01/2004
----------
Spib - Always ignore HTTP streams
Spib - Better detection of Artist & Album info

** 24/01/2004 - VERSION 1.1.5 Build 591 Released **

24/01/2004
----------
Spib - Remember to update the build number this time
Spib - Fix for info fields not cleared between submissions

** 06/01/2004 - VERSION 1.1.4 Build 590 Released **

06/01/2004
----------
Spib - Reconnects (handshakes) if no response received
Spib - Fix buffer overrun
Spib - Fix UTF8 encoding (thanks Case!)
Spib - Fix Winamp directory detection in NSIS
Spib - Ignore HTTP Streams on by default
Spib - Send Cache in small pieces (10 submissions max by default)
Spib - Server responses logged to file by default
Spib - Support for v1.1 Protocol

** 05/07/2003 - VERSION 1.1.3 Build 575 Released **

04/07/2003
----------
Spib - Minimum submit time is now 120s instead of 180s to bring in
       line with the AS protocol.
Spib - Fix for folks with system time set before Jan 2003.
Spib - Additional logging.
Spib - Further critical sections in CScrobbler
Spib - If modem is installed but not used, plugin will try other connections now
       rather than reporting no connections available
Spib - Added 'forceconnection' hidden registry option to allow the user to
       force the plugin to try to connect even if the plugin thinks there
       is no internet connection available.
Spib - Fixed crashbug in CCacheManager::Save() caused by array going
       out of bounds.

** 29/06/2003 - VERSION 1.1.2 Build 566 Released **

29/06/2003
----------
Spib - Critical Sections in CCacheManager

** 08/06/2003 - VERSION 1.1.1 Build 561 Released **

08/06/2003
----------
Spib - Bugfix in CSubmission::Populate to catch long file ext

** 23/05/2003 - VERSION 1.1.0 Build 555 Released **

22/05/2003
----------
Spib - Added option to ignore HTTP streams
Spib - Fixed crashbug under some OS (thanks wertherman)
Spib - Enabling/Disabling plugin doesn't block submissions now
Spib - More useless info added to config dialog
Spib - Config dlg is modeless now so you can keep it open all the time

** 19/05/2003 - VERSION 1.1.0 Beta Released **

16/05/2003
----------
Spib - Doesn't use MFC anymore which should fix some minor resource issues.
Spib - Properly identifies unsupported files now
Spib - Removed ID3 option in config dialog
Spib - Log file max size works now

09/05/2003
----------
Spib - Fix for bug 735171 (Doesn't cache failed submission)
Spib - UTF-8 Bug fixes
Spib - Fix for bug 735635 (Wrong info submitted if playlist changes)
Spib - Loads of work done detecting internet connection state for dial-up users

02/05/2003
----------
Spib - Added Proxy / Proxy Authentication Support
Spib - Fix for bug 732818 (Track titles are cut on some tracks)
Spib - Fix for bug 734180 (Cached files not shown in the Last 5 Submitted)

** 02/05/2003 - VERSION 1.0.4 Released **

02/05/2003
----------
Spib - Fixes to better cope with server outages
Spib - Error messages are more useful, but a bit annoying so...
Spib - Config option to disable error messages
Spib - Better display of Server Response in Config Dialog

** 30/04/2003 - VERSION 1.0.3 Released **

30/04/2003
----------
Spib - Fix for bug 730342 (Plugin doesn't submit CD tracks)
Spib - Fix for bug 729650 (Caches forever after a FAILED response)
Spib - Config dialog updates stats in real time

24/04/2003
----------
Spib - Will work if the internet isn't connected when winamp first starts
Spib - Sends timestamp as GMT
Spib - Fixed a couple of small logging issues
Spib - Cosmetic Fixes
Spib - Prevent Error MessageBox delaying submission caching

** 19/04/2003 - VERSION 1.0.2 Released **

19/04/2003
----------
RJ - Made id3 option default to off
RJ - Updated readme
RJ - Put entire version history into readme, should prolly separate the 2 documents.

** 18/04/2003 - VERSION 1.01 Released **

17/04/2003
-----------
Spib - Added list of last 5 submitted songs on config dialog
Spib - Songs are now submitted after 50% or 180 seconds, whichever comes first

16/04/2003
-------------
Spib - Send cache even when not playing
Spib - Various data logging improvements
Spib - CSubmission::GetFriendlyName() now returns the correct data
Spib - Improved UserAgent identification
Spib - Added Help/Readme

14/04/2003
-------------
Spib - UTF8 encode the track data before it is sent
Spib - Config dialog displayed on new installation
Spib - Option to use ID3 tags for track data
Spib - Changed logging to default to DEBUG_FLOW
Spib - Added hidden registry option to change log level
Spib - Added option to write debug as XML (mostly for my own amusement)
Spib - Removed PrivateHTTPStreams option from config dialog seeing as we don't send the path info anymore

** 10/04/2003 - VERSION 1.00 Released **

09/04/2003
-------------
Spib - Only show badpass errors once
Spib - Logging stuff, filesize works now. Filesize 0 turns off
       logging, size of -1 disables max size on log.
Spib - Added version string to config dialog
Spib - Added info about server response to config dialog


08/04/2003
-----------
Spib - Implemented new client protocol.
Spib - Made submissions respect server-supplied submit interval.
Spib - Changed format of cache file to binary to allow
       easier reading/writing of individual entries.
Spib - Added CWinampController for easier winamp control.
Spib - Added skipping of unsupported media types in submissions
       as requested.
Spib - Added submission cache stats to config dialog.

0.9.9 [10/04/03]


Final change before 1.0 
Stopped plugin from submitting names of videos, avoiding various "adult" titles appearing on the site. (wa2.9 does videos)


0.9.3 [11/02/03]


Decided not to store filename or media type, to avoid possible incriminating data regarding peoples music collections


0.9.2 [10/02/03]


0.9.0 and 0.9.1 never submitted filename, this one does


0.9.0 [10/02/03]


Added option to keep HTTP streams private 
Reduced time-to-submission to 50% of song length 
Additional error handling 

0.8.5 [02/01/03]


Communicates directly with new servers 
Removed unnecessary encryption. (Password still secure) 

0.8.1 [05/12/02]


All HTTP communications are now threaded 
Plugin now writes significant events to logfile 
Option to specify maximum size of logfile 
Option to disable the plugin 
Fixed and tested the offline caching, it should work now! 

0.7.1 [02/12/02]


Wrote my own XOR encrypt/decrypt function in C++ and PHP. 
ALL client-server communication now encrypted 
Plugin will not submit if winamp instances>1 (using semaphores) 
Offline caching is now encrypted 
Server side fix for duplicate/hasty submissions 
Remove read-only flag on cache file before deletion attempt 

0.6.5 [26/11/02]


Hasty fix to 0.6 that caused double submission of all songs 
Rewritten offline caching. Songs played offline are now updated when you connect 

0.6.0 [25/11/02]


Control Centre now handles updates properly 
Password security - MD5 digests are used vs. cleartext 

0.5.0 [23/11/02] (unreleased)


completely new architecture 
stability should be acceptable - i learnt about memory management 
Control Centre now handles client updates 
offline caching removed as it was buggy 

0.4.0 [20/11/02] (unreleased)


minor changes to try and fix stability 

0.3.0 [19/11/02] (unreleased)


resolved failed submissions where & or # appeared in path 
fixed some random bugs and glitches 
updated installer to warn to close winamp 
installer creates start-menu shortcut to readme 

0.2.5 [17/11/02]


comes with an installer (nulsoft) 
you must listen to half the song before submission 
stability is getting better 

0.2.0 [16/11/02]


doesn't crash if you are offline :) 
caches offline submissions for later in plain text file 
fixed bug regarding ' in song name 
plugin reports date and time of client instead of using server time 
plugin reports soundex hash for artist/song 
code cleaned up 

0.1.0 [07/11/02]


server time is used to timestamp submissions 
only works if you are online 
submits playlist text to server 
initial release, testing with me and paul 
no installer, need some MFC DLLs installed to use 


=================
== Known Bugs  ==
=================

+ The ShowConfig() routine doesn't always show the config dialog depending on
  where in the program it is called. This is to do with the plugin trying to 
  load the dialog resource from the app rather than the DLL. AFX_MANAGE_STATE 
  should fix it but it doesn't seem to.
